package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.Objects;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

abstract class AbstractNBTComponentBuilder<C extends NBTComponent<C, B>, B extends NBTComponentBuilder<C, B>> extends AbstractComponentBuilder<C, B> implements NBTComponentBuilder<C, B> {
   protected @Nullable String nbtPath;
   protected boolean interpret = false;
   protected @Nullable Component separator;

   AbstractNBTComponentBuilder() {
   }

   AbstractNBTComponentBuilder(final @NotNull C component) {
      super(component);
      this.nbtPath = component.nbtPath();
      this.interpret = component.interpret();
      this.separator = component.separator();
   }

   public @NotNull B nbtPath(final @NotNull String nbtPath) {
      this.nbtPath = (String)Objects.requireNonNull(nbtPath, "nbtPath");
      return this;
   }

   public @NotNull B interpret(final boolean interpret) {
      this.interpret = interpret;
      return this;
   }

   public @NotNull B separator(final @Nullable ComponentLike separator) {
      this.separator = ComponentLike.unbox(separator);
      return this;
   }
}
